package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;


/**
 * 
 * @Description:   70.母版添加试卷
 * @author: wff    
 * @date: 2019年7月9日 下午4:00:58   
 * @version V1.0
 */
public class addChildModuleExam extends NWN implements API {
	public String parameter;//参数集合
	
	public String template_id_1;//母版id
	public String parent_id ;//父级id
	public String exercise_name ;//练习名称
	public String request_type ;//请求类型(创建  : 1  /继续创建  :2)
	public String exam_id ;//试卷id
	public String answer_enable ;//是否允许重新作答 
	public String download_enable ;//是否允许学员下载
	public String app_show ;//学员端展示(0:没有该设置项或不能设置  1:作答内容2作答内容和解析 3:作答内容,解析和智能批改结果)
	public String submit_time ;//试卷截止提交时间(0:没有设置或者不能设置   其余正常时间戳) 
	public String module_type ;//组件类型 1 文档 2 视频 3 模考 4 试卷 5 练习册'
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
		parent_id = MapUtil.getParameter(parameter, "parent_id").trim();
		exercise_name = MapUtil.getParameter(parameter, "exercise_name").trim();
		request_type = MapUtil.getParameter(parameter, "request_type").trim();
		exam_id = MapUtil.getParameter(parameter, "exam_id").trim();
		answer_enable = MapUtil.getParameter(parameter, "answer_enable").trim();
		download_enable = MapUtil.getParameter(parameter, "download_enable").trim();
		app_show = MapUtil.getParameter(parameter, "app_show").trim();
		submit_time = MapUtil.getParameter(parameter, "submit_time").trim();
		module_type = MapUtil.getParameter(parameter, "module_type").trim();
	
	
		if ((!template_id_1.equals("")) && template_id_1.equals("code")) {
			
			template_id_1 = template_id;
			parameter = parameter.replace("\"template_id\":code", "\"template_id\":\""+ template_id_1 + "\"");
		}
		
		if ((!exam_id.equals("")) && exam_id.equals("code")) {
			exam_id = "175";
			parameter = parameter.replace("\"exam_id\":code", "\"exam_id\":\""+ exam_id + "\"");
		}
		if ((!submit_time.equals("")) && submit_time.equals("code")) {
			Long timeString= System.currentTimeMillis();
			timestamp = timeString.toString().substring(0, 10);
			parameter = parameter.replace("\"submit_time\":code", "\"submit_time\":\""+ timestamp + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				
				level_id_List=jp.getString("data.level_id");
				
				//是否验证数据库
				if (!isProduct) {
					
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
