package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;



/**
 * 67.母版添加试卷或练习册
 * 
 * @author wff
 *
 */
public class addChildModuleExercise extends NWN implements API {
	public String parameter;//参数集合
	
	public String template_id_1;//模板id
	public String parent_id;//父级id
	public String exercise_name;//练习名称
	public String request_type;//请求类型
	public String practice_id;//练习册id
	public String module_type;//类型
	
	@Override
	public void initialize(HashMap<String, Object> data) {
//		try {
//			String sql="SELECT  DISTINCT(video_id)   FROM  n_video  ";
//			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
//			ResultSet rs_bankcard = this.sqlFromDB(sql);
//			rs_bankcard.last();
//			
//			movie_id_list.add(rs_bankcard.getString("video_id"));
//					
//			//System.out.println("movie_id_list====" + movie_id_list);
//		} catch (Exception e) {
//			
//			e.printStackTrace();
//		}
	}
	
//	public static void main(String[] args) {
//		System.out.println("exercise_name......" + "测试练习册" + (int)((Math.random()*9+1)*1000));
//	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
	
		parameter = MapUtil.getValue("parameter", data);
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
		exercise_name = MapUtil.getParameter(parameter, "exercise_name").trim();
		practice_id = MapUtil.getParameter(parameter, "practice_id").trim();
		
		if ((!template_id_1.equals("")) && template_id_1.equals("code")) {
			System.out.println("template_id_1......" + template_id);
			parameter = parameter.replace("\"template_id\":code", "\"template_id\":\""+ template_id + "\"");
		}
		
		if ((!exercise_name.equals("")) && exercise_name.equals("code")) {
//			exercise_name = "测试练习册"+(int)((Math.random()*9+1)*1000);
			exercise_name = "feifei测试练习册";
			System.out.println("exercise_name......" + exercise_name);
			parameter = parameter.replace("\"exercise_name\":code", "\"exercise_name\":\""+ exercise_name + "\"");
		}
		
		if ((!practice_id.equals("")) && practice_id.equals("code")) {
			practice_id = "31";
			parameter = parameter.replace("\"practice_id\":code", "\"practice_id\":\""+ practice_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				
				//是否验证数据库
				if (!isProduct) {
					
					try {
						String sql="SELECT id,practice_id,exercise_name,menu_id FROM iip.n_practice ORDER BY id DESC LIMIT 1";
						
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						
						if (rs_bankcard.getRow() < 1) {
							result = result && false;
							failReason = failReason + "xyu_room_topic info is not in DB;";
						}else{
							//存储练习册id
							practiceId = rs_bankcard.getString("id");
							menuId = rs_bankcard.getString("menu_id");
							
							if (!rs_bankcard.getString("practice_id").equals(practice_id)) {
								result = result && false;
								failReason = failReason + "nwn.n_practice info is not in DB;";
							}
							if(!rs_bankcard.getString("exercise_name").equals(exercise_name)){
								result = result && false;
								failReason = failReason + "nwn.n_practice info is not in DB;";
							}
						}
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify xyu_room_topic info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
