package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;



/**
 * 
 * @Description:   15. 课程大纲列表--添加练习册或试卷组件
 * @author: wff    
 * @date: 2019年7月10日 上午10:35:59   
 * @version V1.0
 */
public class addChildModuleExercise_1 extends NWN implements API {
	public String parameter;//参数集合
	
	public String package_id;//学习包id
	public String parent_id;//父级id
	public String module_type;//添加类型
	public String exam_id;//试卷id
	public String exercise_name;//练习名称
	public String practice_id;//练习册id
	public String download_enable;//是否允许下载
	public String answer_enable;//是否允许重新作答
	public String app_show;//学员端展示
	public String submit_time;//试卷截止提交时间
	
	
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		package_id = MapUtil.getParameter(parameter, "package_id").trim();
		parent_id = MapUtil.getParameter(parameter, "parent_id").trim();
		module_type = MapUtil.getParameter(parameter, "module_type").trim();
		exam_id = MapUtil.getParameter(parameter, "exam_id").trim();
		exercise_name = MapUtil.getParameter(parameter, "exercise_name").trim();
		practice_id = MapUtil.getParameter(parameter, "practice_id").trim();
		download_enable = MapUtil.getParameter(parameter, "download_enable").trim();
		app_show = MapUtil.getParameter(parameter, "app_show").trim();
		submit_time = MapUtil.getParameter(parameter, "submit_time").trim();
		
		
		if ((!package_id.equals("")) && package_id.equals("code")) {
//			package_id=ListUtil.getListValue(n_package_idList, 0);
			package_id= "2077";
			parameter = parameter.replace("\"package_id\":code", "\"package_id\":\""+ package_id + "\"");
		}
		if ((!practice_id.equals("")) && practice_id.equals("code")) {
			practice_id= "";
			parameter = parameter.replace("\"practice_id\":code", "\"practice_id\":\""+ practice_id + "\"");
		}
		if ((!exam_id.equals("")) && exam_id.equals("code")) {
			exam_id= "4321";
			parameter = parameter.replace("\"exam_id\":code", "\"exam_id\":\""+ exam_id + "\"");
		}
		if ((!submit_time.equals("")) && submit_time.equals("code")) {
			Long timeString= System.currentTimeMillis();
			timestamp = timeString.toString().substring(0, 10);
			parameter = parameter.replace("\"submit_time\":code", "\"submit_time\":\""+ timestamp + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl("/admin/package/addChildModuleExercise");
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		
//		Response re = RequestDataUtils.Get_one_cookie_pre(data, "/admin/package/addChildModuleExercise", "PHPSESSID",PHPSESSID);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				
				level_id_List=jp.getString("data.level_id");
				
				//是否验证数据库
				if (!isProduct) {
					
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
