package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;



/**
 * 课程大纲列表-添加组件-文件
 * 
 * @author puhui
 *
 */
public class addChildModuleFile extends NWN implements API {
	public String parameter;//参数集合
	public String id;//层级ID
	public String n_template_menu_value;
	public String template_id_1;//学习包id
	public String doc_name;//文件名称
	public String parent_id ;//movid_id的id 
	
	public String doc_url;//文档地址-url
	public String share_enable;//是否可分享(0不可分享 1 可分享)',
	
	@Override
	public void initialize(HashMap<String, Object> data) {
		
		try {
			String sql="SELECT  MAX(id) AS id  FROM  n_template  ";
			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			id =  rs_bankcard.getString("id");

			
		} catch (Exception e) {
			
			e.printStackTrace();
		}
		
		
		try {
			if(Integer.parseInt(id) < 100)
			{
				n_template_menu_value = "n_template_menu_" +id ;
				
			}else {
				n_template_menu_value = "n_template_menu_" + Integer.parseInt(id)%100 ;
				
			}
			
			String sql="SELECT MAX(id) as id  FROM nwn_template."+n_template_menu_value +" where template_id =" + id  ;
			//String sql="SELECT id  FROM nwn_template."+n_template_menu_value +" where template_id =" + 1613  ;
			
						System.out.println(sql);
			ResultSet rs_bankcard = this.sqlFromDB_template(sql);
			
			rs_bankcard.last();
			parent_id =  rs_bankcard.getString("id");
			System.out.println("parent_id============"+ rs_bankcard.getString("id"));
			
		} catch (Exception e) {
			
			e.printStackTrace();
		}
		
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
		
		parent_id = MapUtil.getParameter(parameter, "parent_id").trim();
	
	
		if ((!template_id_1.equals("")) && template_id_1.equals("template_id")) {
			
			template_id_1 = template_id;
			parameter = parameter.replace("\"template_id\":template_id", "\"template_id\":\""+ template_id_1 + "\"");
		}
		
		if ((!parent_id.equals("")) && parent_id.equals("parent_id")) {
		
			parameter = parameter.replace("\"parent_id\":parent_id", "\"parent_id\":\""+ parent_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				
				level_id_List=jp.getString("data.level_id");
				
				//是否验证数据库
				if (!isProduct) {
					
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
