package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;

import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;



/**
 * 
 * @Description:  83.教务包直播组件批量更新 
 * @author: wff    
 * @date: 2019年10月22日 上午9:45:39   
 * @version V1.0
 */

public class banchImportEditLive extends NWN implements API {
	public String parameter;//参数集合
	
	public String package_id ;//学习包或者教务包ID  强转int  默认0
	public String file ;//excel文件
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		package_id = MapUtil.getParameter(parameter, "package_id").trim();
		file = MapUtil.getParameter(parameter, "file").trim();
	
		if ((!package_id.equals("")) && package_id.equals("code")) {
			package_id = "4028778";
			parameter = parameter.replace("\"package_id\":code", "\"package_id\":\""+ package_id + "\"");
		}
		if ((!file.equals("")) && file.equals("code")) {
			file = "zb.xlsx";
			parameter = parameter.replace("\"file\":code", "\"file\":\""+ file + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		Map<String, String> formFileParameter=new HashMap<String, String>();
		formFileParameter.put("package_id", package_id);
//		formFileParameter.put("file", "/out"+ file);
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setFormFileParameter(formFileParameter);
		myRequest.setCookies(cookie);
		myRequest.setFormFile(file);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				//讲义对应的menuid
				menuId = jp.getString("data.level_id");
				//是否验证数据库
				if (!isProduct) {
					try {
						String sql = "SELECT MAX(id) id,menu_id,name FROM n_handouts";
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						//添加讲义的主键id
						handoutsId = rs_bankcard.getString("id");
////						System.out.println(rs_bankcard.getString("name"));
////						if(!(rs_bankcard.getString("name")).equals(handouts_name)){
////							result = result && false;
////							failReason = failReason + "template_id info in DB is wrong;";
////						}
//						System.out.println(menuId);
//						System.out.println(liveId);
//						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
					}
				}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
