package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.apache.log4j.chainsaw.Main;
import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.system.system;

import net.sf.json.JSONObject;



/**
 * 
 * @Description:  158. 直播间作业 -- 校验试卷
 * @author: wff    
 * @date: 2020年4月28日 下午9:51  
 * @version V1.0
 */
public class checkExam_zhibo extends NWN implements API {
	public String parameter;//参数集合
	
	public String admin_card_no;//教务当前登录用户的 mis账号（如：zwq50680）
	public String admin_sso_id;//教务当前登录用户的sso_id
	public String store_id;//教务当前的登录店铺id
	public String token;// 教务token
	public String exam_id;//试卷ID
	public String little_id;//组件ID
	public String ssoId;//类型
	@Override
	public void initialize(HashMap<String, Object> data) {
		
		try {
			String sql ="SELECT sso_id FROM iip.n_user WHERE phone = '15201350979'";
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			ssoId = rs_bankcard.getString("sso_id");
		} catch (Exception e) {
			// TODO: handle exception
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		admin_sso_id = MapUtil.getParameter_get(parameter, "admin_sso_id").trim();
		admin_card_no = MapUtil.getParameter_get(parameter, "admin_card_no").trim();
		store_id = MapUtil.getParameter_get(parameter, "store_id").trim();
		token = MapUtil.getParameter_get(parameter, "token").trim();
		exam_id = MapUtil.getParameter_get(parameter, "exam_id").trim();
		little_id = MapUtil.getParameter_get(parameter, "little_id").trim();
		
		if ((!admin_sso_id.equals("")) && admin_sso_id.equals("code")) {
//			ssoIds= "1" + new Random().nextInt(9000000);
//			ssoIds= "5412389";
			admin_sso_id= ssoId;
//			ssoIds= "7323436,7323436";
			parameter = parameter.replace("admin_sso_id=code", "admin_sso_id="+ admin_sso_id );
		}
		if((!admin_card_no.equals("")) && admin_card_no.equals("code")) {
			admin_card_no = "wff66504";
			parameter = parameter.replace("admin_card_no=code", "admin_card_no="+ admin_card_no );
		}
		if((!store_id.equals("")) && store_id.equals("code")) {
			store_id = "1";
			parameter = parameter.replace("store_id=code", "store_id="+ store_id );
		}
		if((!token.equals("")) && token.equals("code")) {
			token = jw_token;
			parameter = parameter.replace("token=code", "token="+ token );
		}
		if((!exam_id.equals("")) && exam_id.equals("code")) {
			exam_id = "6003";
			parameter = parameter.replace("exam_id=code", "exam_id="+ exam_id );
		}
		if((!little_id.equals("")) && little_id.equals("code")) {
			little_id = "3011";
			parameter = parameter.replace("little_id=code", "little_id="+ little_id );
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String,String> cookies=new HashMap<String,String>();
//		cookies.put("admin_31_encode", admin_31_encode);
		cookies.put("PHPSESSID", PHPSESSID);
//		cookies.put("admin_login_ssid", admin_login_ssid);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setUrl("/admin/package/edu/task/checkExam");
		myRequest.setCookies(cookies);
		myRequest.setRequest(Request);
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
//		System.out.println(re.asString());
//		System.out.println(StringUtils.decodeUnicode(re.asString()));
		
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

//		System.out.println(json);
		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null ){
//				String sso_id=jp.getString("data[0].sso_id");
//				if(!data.get("custom").equals(sso_id)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
//				}
					
			}
			
			if("0".equals(code) ){
//				i_module_id = jp.getString("data.module_id");
//				System.out.println(i_module_id);
			}
			
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
