package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;



/**
 * 课程大纲列表-添加组件-视频
 * 
 * @author puhui
 *
 */
public class editExercise extends NWN implements API {
	public String parameter;//参数集合
	
	public String type;//1:获取信息 2:保存修改(均为必填)
	public String module_type;//类型(4:试卷 5:练习册)
	public String package_id;//学习包id(均为必填)
	public String menu_id;//上一级获取到的id(均为必填)
	public String current_id;//获取信息的时候返回的id(修改的时候必须填)
	public String exercise_name;//练习名称(修改的时候必须填)
	public String practice_id;//题库中练习册id(获取的时候非必须, 修改的时候必须填)
	public String exam_id;//试卷id (获取的时候非必须, 修改的时候必须填)
	public String download_enable;//是否允许下载(获取的时候非必须, 修改的时候必须填)
	public String answer_enable;//试卷是否允许重新作答(获取的时候非必须, 修改的时候必须填)
	public String request_type;//保存校验
	public String app_show;//学员端展示(1:作答内容 2:作答内容和解析 3:作答内容,解析和智能批改结果)
	public String submit_time;//试卷截止提交时间(0:无其余正常)
	
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		type = MapUtil.getParameter(parameter, "type").trim();
		module_type = MapUtil.getParameter(parameter, "module_type").trim();
		package_id = MapUtil.getParameter(parameter, "package_id").trim();
		menu_id = MapUtil.getParameter(parameter, "menu_id").trim();
		current_id = MapUtil.getParameter(parameter, "current_id").trim();
		exercise_name = MapUtil.getParameter(parameter, "exercise_name").trim();
		practice_id = MapUtil.getParameter(parameter, "practice_id").trim();
		exam_id = MapUtil.getParameter(parameter, "exam_id").trim();
		download_enable = MapUtil.getParameter(parameter, "download_enable").trim();
		answer_enable = MapUtil.getParameter(parameter, "answer_enable").trim();
		request_type = MapUtil.getParameter(parameter, "request_type").trim();
		app_show = MapUtil.getParameter(parameter, "app_show").trim();
		submit_time = MapUtil.getParameter(parameter, "submit_time").trim();
		
		if ((!package_id.equals("")) && package_id.equals("code")) {
			package_id=ListUtil.getListValue(n_package_idList, 0);
//			parameter = parameter.replace("package_id=code", "package_id="+ package_id );
			parameter = parameter.replace("\"package_id\":code", "\"package_id\":\""+ package_id + "\"");
		}
		if ((!menu_id.equals("")) && menu_id.equals("code")) {
			menu_id= menuId;
//			parameter = parameter.replace("menu_id=code", "menu_id="+ menu_id );
			parameter = parameter.replace("\"menu_id\":code", "\"menu_id\":\""+ menu_id + "\"");
		}
		if ((!current_id.equals("")) && current_id.equals("code")) {
			current_id= "1";
//			parameter = parameter.replace("current_id=code", "current_id="+ current_id );
			parameter = parameter.replace("\"current_id\":code", "\"current_id\":\""+ current_id + "\"");
		}
		if ((!practice_id.equals("")) && practice_id.equals("code")) {
			practice_id= "31";
//			parameter = parameter.replace("practice_id=code", "practice_id="+ practice_id );
			parameter = parameter.replace("\"practice_id\":code", "\"practice_id\":\""+ practice_id + "\"");
		}
		if ((!exam_id.equals("")) && exam_id.equals("code")) {
			exam_id= "175";
//			parameter = parameter.replace("exam_id=code", "exam_id="+ exam_id );
			parameter = parameter.replace("\"exam_id\":code", "\"exam_id\":\""+ exam_id + "\"");
		}
		if ((!submit_time.equals("")) && submit_time.equals("code")) {
			Long timeString= System.currentTimeMillis();
			timestamp = timeString.toString().substring(0, 10);
//			parameter = parameter.replace("submit_time=code", "submit_time="+ timestamp );
			parameter = parameter.replace("\"submit_time\":code", "\"submit_time\":\""+ submit_time + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		
//		Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				
				level_id_List=jp.getString("data.level_id");
				
				//是否验证数据库
				if (!isProduct) {
					
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
