package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;


/**
 * 
 * @Description:   79.编辑讲义-保存讲义
 * @author: wff    
 * @date: 2019年8月23日 上午9:26:59   
 * @version V1.0
 */

public class editHandoutsInfo extends NWN implements API {
	public String parameter;//参数集合
	
	public String template_id_1;//母版id
	public String menu_id ;//当前讲义id
	public String handouts_name ;//直播名
	public String handouts_path ;//日期
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
		menu_id = MapUtil.getParameter(parameter, "menu_id").trim();
		handouts_name = MapUtil.getParameter(parameter, "handouts_name").trim();
		handouts_path = MapUtil.getParameter(parameter, "handouts_path").trim();
	
		if ((!template_id_1.equals("")) && template_id_1.equals("code")) {
			template_id_1 = template_id;
			parameter = parameter.replace("\"template_id\":code", "\"template_id\":\""+ template_id_1 + "\"");
		}
		
		if ((!menu_id.equals("")) && menu_id.equals("code")) {
			menu_id = menuId;
			parameter = parameter.replace("\"menu_id\":code", "\"menu_id\":\""+ menu_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				//讲义对应的menuid
				menuId = jp.getString("data.level_id");
				//是否验证数据库
				if (!isProduct) {
					try {
						String sql = "SELECT MAX(id) id,menu_id,name FROM n_handouts";
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						//添加讲义的主键id
						handoutsId = rs_bankcard.getString("id");
////						System.out.println(rs_bankcard.getString("name"));
////						if(!(rs_bankcard.getString("name")).equals(handouts_name)){
////							result = result && false;
////							failReason = failReason + "template_id info in DB is wrong;";
////						}
//						System.out.println(menuId);
//						System.out.println(liveId);
//						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
					}
				}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
