package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;


/**
 * 
 * @Description:   76.编辑直播课-保存
 * @author: wff    
 * @date: 2019年8月21日 上午9:41:58   
 * @version V1.0
 */
public class editLive extends NWN implements API {
	public String parameter;//参数集合
	
	public String template_id_1;//母版id
	public String menu_id ;//该组件的id
	public String live_name ;//直播名
	public String date_time ;//日期
	public String start_time ;//直播开始时间
	public String end_time ;//直播结束时间
	public String operator ;//运营商
	public String class_type ;//班级类型
	public String subject_id ;//授课内容
	public String enter_last_time ;//最后进入教室时间
	public String teach_content ;//授课文件json数组
	public String instructions ;//使用说明
	
	
	@Override
	public void initialize(HashMap<String, Object> data) {
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		template_id_1 = MapUtil.getParameter(parameter, "template_id").trim();
		menu_id = MapUtil.getParameter(parameter, "menu_id").trim();
		live_name = MapUtil.getParameter(parameter, "live_name").trim();
		date_time = MapUtil.getParameter(parameter, "date_time").trim();
		start_time = MapUtil.getParameter(parameter, "start_time").trim();
		end_time = MapUtil.getParameter(parameter, "end_time").trim();
		operator = MapUtil.getParameter(parameter, "operator").trim();
		class_type = MapUtil.getParameter(parameter, "class_type").trim();
		subject_id = MapUtil.getParameter(parameter, "subject_id").trim();
		enter_last_time = MapUtil.getParameter(parameter, "enter_last_time").trim();
		teach_content = MapUtil.getParameter(parameter, "teach_content").trim();
		instructions = MapUtil.getParameter(parameter, "instructions").trim();
	
		if ((!template_id_1.equals("")) && template_id_1.equals("code")) {
			template_id_1 = template_id;
			parameter = parameter.replace("\"template_id\":code", "\"template_id\":\""+ template_id_1 + "\"");
		}
		
		if ((!menu_id.equals("")) && menu_id.equals("code")) {
			menu_id = menuId;
			parameter = parameter.replace("\"menu_id\":code", "\"menu_id\":\""+ menu_id + "\"");
		}
		if ((!date_time.equals("")) && date_time.equals("code")) {
			date_time = MyDateUtil.getDateTime();
			parameter = parameter.replace("\"date_time\":code", "\"date_time\":\""+ date_time + "\"");
		}
		if ((!start_time.equals("")) && start_time.equals("code")) {
			start_time = MyDateUtil.getHourTime(0, 5);
			parameter = parameter.replace("\"start_time\":code", "\"start_time\":\""+ start_time + "\"");
		}
		if ((!end_time.equals("")) && end_time.equals("code")) {
			end_time = MyDateUtil.getHourTime(1, 0);
			parameter = parameter.replace("\"end_time\":code", "\"end_time\":\""+ end_time + "\"");
		}
		if ((!enter_last_time.equals("")) && enter_last_time.equals("code")) {
			enter_last_time = "1-1";
			parameter = parameter.replace("\"enter_last_time\":code", "\"enter_last_time\":\""+ enter_last_time + "\"");
		}
		if ((!teach_content.equals("")) && teach_content.equals("code")) {
			teach_content = "[{\\\"teach_url\\\":\\\"www.baidu.com\\\",\\\"teach_name\\\":\\\"文件名1\\\"}]";
			parameter = parameter.replace("\"teach_content\":code", "\"teach_content\":\""+ teach_content + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	public static void main(String[] args) {
		String start_time = MyDateUtil.getTime(2, 2, 2);
		System.out.println(start_time);
	}
	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				//直播对应的menuid
				menuId = jp.getString("data.level_id");
				//是否验证数据库
				if (!isProduct) {
					try {
						String sql = "SELECT MAX(id) id,menu_id,live_name FROM n_live";
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						//添加直播的主键id
						liveId = rs_bankcard.getString("id");
//						System.out.println(rs_bankcard.getString("live_name"));
//						if(!(rs_bankcard.getString("live_name")).equals(live_name)){
//							result = result && false;
//							failReason = failReason + "template_id info in DB is wrong;";
//						}
						System.out.println(menuId);
						System.out.println(liveId);
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
					}
				}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
