package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.apache.log4j.chainsaw.Main;
import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.system.system;

import net.sf.json.JSONObject;



/**
 * 
 * @Description:  154. 直播间作业 -- 编辑视频作业
 * @author: wff    
 * @date: 2020年4月26日 下午13:51  
 * @version V1.0
 */
public class editVideoTask extends NWN implements API {
	public String parameter;//参数集合
	
	public String admin_card_no;//教务当前登录用户的 mis账号（如：zwq50680）
	public String admin_sso_id;//教务当前登录用户的sso_id
	public String store_id;//教务当前的登录店铺id
	public String token;// 教务token
	public String movie_name;//文档名称
	public String movie_id;//上传文件名称
	public String module_type;//上传文件名称
	public String module_id;//上传文件名称
	public String ssoId;//
	
	@Override
	public void initialize(HashMap<String, Object> data) {
		
		try {
			String sql ="SELECT sso_id FROM iip.n_user WHERE phone = '15201350979'";
			ResultSet rs_bankcard = this.sqlFromDB(sql);
			rs_bankcard.last();
			ssoId = rs_bankcard.getString("sso_id");
			
			String sql2="SELECT  DISTINCT(video_id)   FROM  n_video  ";
			//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
			ResultSet rs_bankcard2 = this.sqlFromDB(sql2);
			rs_bankcard2.last();
			
			movie_id_list.add(rs_bankcard2.getString("video_id"));
		} catch (Exception e) {
			// TODO: handle exception
		}
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		admin_sso_id = MapUtil.getParameter(parameter, "admin_sso_id").trim();
		admin_card_no = MapUtil.getParameter(parameter, "admin_card_no").trim();
		store_id = MapUtil.getParameter(parameter, "store_id").trim();
		token = MapUtil.getParameter(parameter, "token").trim();
		movie_id = MapUtil.getParameter(parameter, "movie_id").trim();
		module_id = MapUtil.getParameter(parameter, "module_id").trim();
		movie_name = MapUtil.getParameter(parameter, "movie_name").trim();
		module_type = MapUtil.getParameter(parameter, "module_type").trim();
		
		if ((!admin_sso_id.equals("")) && admin_sso_id.equals("code")) {
//			ssoIds= "1" + new Random().nextInt(9000000);
//			ssoIds= "5412389";
			admin_sso_id= ssoId;
//			ssoIds= "7323436,7323436";
//			parameter = parameter.replace("\"admin_sso_id\":code", "\"admin_sso_id\":\""+ admin_sso_id + "\"");
		}
		if((!admin_card_no.equals("")) && admin_card_no.equals("code")) {
			admin_card_no = "wff66504";
//			parameter = parameter.replace("\"admin_card_no\":code", "\"admin_card_no\":\""+ admin_card_no + "\"");
		}
		if((!store_id.equals("")) && store_id.equals("code")) {
			store_id = "1";
//			parameter = parameter.replace("\"store_id\":code", "\"store_id\":\""+ store_id + "\"");
		}
		if((!token.equals("")) && token.equals("code")) {
			token = jw_token;
//			parameter = parameter.replace("\"token\":code", "\"token\":\""+ token + "\"");
		}
		if((!movie_id.equals("")) && movie_id.equals("code")) {
			movie_id = ListUtil.getListValue(movie_id_list, 0);
//			parameter = parameter.replace("\"movie_id\":code", "\"movie_id\":\""+ movie_id + "\"");
		}
		if((!module_id.equals("")) && module_id.equals("code")) {
			module_id = i_v_module_id;
//			parameter = parameter.replace("\"movie_id\":code", "\"movie_id\":\""+ movie_id + "\"");
		}
		if((!movie_name.equals("")) && movie_name.equals("code")) {
			movie_name = "飞飞视频做作业2";
//			parameter = parameter.replace("\"movie_id\":code", "\"movie_id\":\""+ movie_id + "\"");
		}
		if((!module_type.equals("")) && module_type.equals("code")) {
			module_type = "2";
//			parameter = parameter.replace("\"movie_id\":code", "\"movie_id\":\""+ movie_id + "\"");
		}
//		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String,String> cookies=new HashMap<String,String>();
//		cookies.put("admin_31_encode", admin_31_encode);
		cookies.put("PHPSESSID", PHPSESSID);
//		cookies.put("admin_login_ssid", admin_login_ssid);
		
		HashMap<String, String> formParameter = new HashMap<String, String>();
		formParameter.put("admin_sso_id", admin_sso_id);
		formParameter.put("admin_card_no", admin_card_no);
		formParameter.put("store_id", store_id);
		formParameter.put("token", token);
		formParameter.put("movie_id", movie_id);
		formParameter.put("movie_name", movie_name);
		formParameter.put("module_type", module_type);
		formParameter.put("module_id", module_id);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setUrl(Url);
		myRequest.setCookies(cookies);
		myRequest.setRequest(Request);
		myRequest.setFormParameter(formParameter);
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
//		System.out.println(re.asString());
//		System.out.println(StringUtils.decodeUnicode(re.asString()));
		
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

//		System.out.println(json);
		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null ){
//				String sso_id=jp.getString("data[0].sso_id");
//				if(!data.get("custom").equals(sso_id)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
//				}
					
			}
			
			if("0".equals(code) ){
				
			}
			
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
