package com.offcn.api.nwn.ht;



import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 学习包信息-常态
 * 
 * @author liyy
 *
 */
public class getCode extends NWN implements API {

	public String parameter;//参数集合
	
	public String package_id;//搜索-学习包id
	public String id;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		package_id = MapUtil.getParameter_get(parameter, "package_id").trim();
		id = MapUtil.getParameter_get(parameter, "id").trim();
		
		if ((!package_id.equals("")) && package_id.equals("package_id")) {
			package_id=ListUtil.getListValue(n_package_idList, 0);
			parameter = parameter.replace("package_id=package_id", "package_id="+ package_id );
		}
		
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
			
		Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		//Response re = RequestDataUtils.Get_one_cookie(data, serviceURL, cookie1Name, cookie1value)   //只能无参
//		Response re = RequestDataUtils.Get_token(data, Url, "");
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("0".equals(code)){
				
			
					
					//是否验证数据库
					if (!isProduct) {
						
						try {
							
						
							getcode_id_List.add(package_id);
							
							//清除n_packcode_record
							String sql="select  getcode   from  n_packcode  where package_id='"+package_id+"'";
							
							ResultSet rs_bankcard = this.sqlFromDB(sql);
							rs_bankcard.last();
							
												
							n_getcode_id_List.add(rs_bankcard.getString("getcode"));
					
							
						} catch (Exception e) {
							result = result && false;
							failReason = failReason + "cannot verify n_packcode info in DB;";
							e.printStackTrace();
						}
					}
				
				}
			}
			
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
