package com.offcn.api.nwn.ht;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;


/**
 * 
 * @Description:   82.教务包编辑直播组件-保存信息
 * @author: 
 * @date: 2019年10月15日 上午9:26:59   
 * @version V1.0
 */

public class saveLiveInfo extends NWN implements API {
	public String parameter;//参数集合
	
	/*public String template_id_1;//母版id
	public String menu_id ;//当前讲义id
	public String handouts_name ;//直播名
	public String handouts_path ;//日期
	*/
	public String package_id;
	public String level_id;
	public String live_name;
	public String date_time;
	public String start_time;
	public String end_time;
	public String room_id;
	public String room_type;
	public String subject_id;
	public String is_choice_type;
	
	@Override
	public void initialize(HashMap<String, Object> data) {
				
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
	
		package_id = MapUtil.getParameter(parameter, "package_id").trim();
		level_id = MapUtil.getParameter(parameter, "level_id").trim();
		live_name = MapUtil.getParameter(parameter, "live_name").trim();
		date_time = MapUtil.getParameter(parameter, "date_time").trim();
		start_time = MapUtil.getParameter(parameter, "start_time").trim();
		end_time = MapUtil.getParameter(parameter, "end_time").trim();
		room_id = MapUtil.getParameter(parameter, "room_id").trim();
		room_type = MapUtil.getParameter(parameter, "room_type").trim();
		subject_id = MapUtil.getParameter(parameter, "subject_id").trim();
		
	
		if ((!package_id.equals("")) && package_id.equals("code")) {
			package_id = "4029219";
			parameter = parameter.replace("\"package_id\":code", "\"package_id\":\""+ package_id + "\"");
		}
		
		if ((!level_id.equals("")) && level_id.equals("code")) {   
			level_id =liveId; 
			parameter = parameter.replace("\"level_id\":code", "\"level_id\":\""+ level_id + "\"");
		}
		if ((!live_name.equals("")) && live_name.equals("code")) {
			live_name = "直播111";
			parameter = parameter.replace("\"live_name\":code", "\"live_name\":\""+ live_name + "\"");
		}
		
		if ((!date_time.equals("")) && date_time.equals("code")) {
			date_time = "2019-11-09";
			parameter = parameter.replace("\"date_time\":code", "\"date_time\":\""+ date_time + "\"");
		}
		if ((!start_time.equals("")) && start_time.equals("code")) {
			start_time = "15:00";
			parameter = parameter.replace("\"start_time\":code", "\"start_time\":\""+ start_time + "\"");
		}
		
		if ((!end_time.equals("")) && end_time.equals("code")) {
			end_time = "17:00";
			parameter = parameter.replace("\"end_time\":code", "\"end_time\":\""+ end_time + "\"");
		}
		
		
		if ((!room_id.equals("")) &&room_id.equals("code")) {
			room_id = "";
			parameter = parameter.replace("\"room_id\":code", "\"room_id\":\""+ room_id + "\"");
		}
	
		if ((!subject_id.equals("")) && subject_id.equals("code")) {
			subject_id = "1";
			parameter = parameter.replace("\"subject_id\":code", "\"subject_id\":\""+ subject_id + "\"");
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		
		Map<String, String> cookie=new HashMap<String, String>();
		cookie.put("PHPSESSID", PHPSESSID);		
		MyRequest myRequest=new MyRequest();
		myRequest.setRequest(Request);
		myRequest.setUrl(Url);
		myRequest.setParameter(parameter);
		myRequest.setCookies(cookie);
		Response re = RequestDataUtils.RestAssuredApi(data,myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				//讲义对应的menuid
				menuId = jp.getString("data.level_id");
				//是否验证数据库
				if (!isProduct) {
					try {
						String sql = "SELECT MAX(id) id,menu_id,name FROM n_handouts";
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						//添加讲义的主键id
						handoutsId = rs_bankcard.getString("id");
////						System.out.println(rs_bankcard.getString("name"));
////						if(!(rs_bankcard.getString("name")).equals(handouts_name)){
////							result = result && false;
////							failReason = failReason + "template_id info in DB is wrong;";
////						}
//						System.out.println(menuId);
//						System.out.println(liveId);
//						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
					}
				}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
