package com.offcn.api.nwn.service;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;

import net.sf.json.JSONObject;



/**
 * 
 * @Description:   51.批量检查学习包是否存在
 * @author: wff    
 * @date: 2019年10月24日 上午11:52:58   
 * @version V1.0
 */
public class checkPackageExists extends NWN implements API {
	public String parameter;//参数集合
	
	public String packageIds;//学习包id
	public String store_id;//学习包id
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		packageIds = MapUtil.getParameter_get(parameter, "packageIds").trim();
		store_id = MapUtil.getParameter_get(parameter, "store_id").trim();
		
		if ((!packageIds.equals("")) && packageIds.equals("code")) {
			packageIds= ListUtil.getListValue(n_package_idList, 0);
			parameter = parameter.replace("packageIds=code", "packageIds="+ packageIds );
		}
		if ((!store_id.equals("")) && store_id.equals("code")) {
			store_id= "2";
			parameter = parameter.replace("store_id=code", "store_id="+ store_id );
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String,String> cookies=new HashMap<String,String>();
//		cookies.put("admin_31_encode", admin_31_encode);
		cookies.put("PHPSESSID", PHPSESSID);
//		cookies.put("admin_login_ssid", admin_login_ssid);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setUrl(Url);
		myRequest.setCookies(cookies);
		myRequest.setRequest(Request);
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
//		System.out.println(re.asString());
//		System.out.println(StringUtils.decodeUnicode(re.asString()));
		
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

//		System.out.println(json);
		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("0".equals(code) && data.get("CleanDB").toString().contains("Y")){
				try {
					deleteFromDB("iip.n_package", "id", packageIds);
				} catch (Exception e) {
					// TODO: handle exception
					e.getMessage();
				}
			}
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
