package com.offcn.api.nwn.service;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 
 * @Description:   20.编辑班级信息
 * @author: wff    
 * @date: 2019年6月21日 下午2:57:49   
 * @version V1.0
 */
public class editPackageInfo extends NWN implements API {
	
	public String parameter;//参数集合
	
	public String package_id;//班级id
	public String pack_name;//名称
	public String for_year;//适用年份
	public String intro;//简介
	public String remark;//备注
	public String cover;//封面
//	public String appid;//appid

	@Override
	public void initialize(HashMap<String, Object> data) {
		
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		
		
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		
		package_id = MapUtil.getParameter(parameter, "package_id").trim();
		pack_name = MapUtil.getParameter(parameter, "pack_name").trim();
		for_year = MapUtil.getParameter(parameter, "for_year").trim();
		intro = MapUtil.getParameter(parameter, "intro").trim();
		remark = MapUtil.getParameter(parameter, "remark").trim();
		cover = MapUtil.getParameter(parameter, "cover").trim();
//		appid = MapUtil.getParameter(parameter, "appid").trim();
//		timestamp = MapUtil.getParameter(parameter, "timestamp").trim();
		
		if ((!package_id.equals("")) && package_id.equals("code")) {
			package_id = "4027483";
			parameter = parameter.replace("\"package_id\":code", "\"package_id\":" + package_id);
		}
//		if ((!timestamp.equals("")) && timestamp.equals("code")) {
//			Long timeString= System.currentTimeMillis();
//			timestamp = timeString.toString().substring(0, 10);
//			parameter = parameter.replace("\"timestamp\":code", "\"timestamp\":" + timestamp);
//		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
//		Map<String,String> m=new HashMap<String,String>();
//		m.put("user_info", parameter);
		//Response re = RequestDataUtils.Post_cooike_form_data(data, Url,"PHPSESSID",PHPSESSID,m);	
//		Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		//Response re = RequestDataUtils.Get_one_cookie(data, serviceURL, cookie1Name, cookie1value)   //只能无参
//		Response re = RequestDataUtils.Get_token(data, Url, "");
		Map<String,String> cookies=new HashMap<String,String>();
		cookies.put("PHPSESSID", PHPSESSID);
		/*Map<String,String> token=new HashMap<String,String>();
		token.put("Authorization", tk_token);*/

		MyRequest myRequest=new MyRequest();
		myRequest.setParameter(parameter);
		myRequest.setUrl(Url);
		myRequest.setRequest(Request);
		myRequest.setCookies(cookies);
		
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		System.out.println( "jp===="+ jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && json!=null){
				//如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if(data.get("custom").toString().contains(",")){
					String [] strCustomStrings=data.get("custom").toString().split(",");
					System.out.println(strCustomStrings.length);
					for(int i=0;i<strCustomStrings.length;i++){
						if(!json.contains(strCustomStrings[i])){
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString() + " but actually "
									+ strCustomStrings[i] + ".";
							break;
						}
					}
				}else{//如果只有一个希望结果，就直接包含比较。
					if(!json.contains(data.get("custom").toString())){
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString() + " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}
			
			
			
			if("0".equals(code)){
				
			
				/*//是否验证数据库
				if (!isProduct) {
					
					template_id=jp.getString("data.id").substring(0,jp.getString("data.id").length());
					
					System.out.println("template_id====="+ template_id );
					try {
						String sql="SELECT  MAX(id) AS id  FROM  n_template  ";
						//SELECT  id FROM  n_template ORDER BY id DESC LIMIT 1
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						System.out.println("after db_templateid============"+ rs_bankcard.getString("id"));
						if(Integer.parseInt(rs_bankcard.getString("id")) > Integer.parseInt("1") )
						{
							if(!template_id.equals(rs_bankcard.getString("id")))
								
							{
								result = result && false;
								failReason = failReason + "template_id info in DB is wrong;";
							}else {
								
								Log.logInfo("template_id info in DB is correct;");
							}
						}else {
							result = result && false;
							failReason = failReason + "template_id info in DB is wrong;";
						}
						
						
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify template_id info in DB;";
						e.printStackTrace();
					}
				}
			*/
			
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
