package com.offcn.api.nwn.service;


import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

import net.sf.json.JSONObject;



/**
 * 
 * @author lm
 *
 */
public class getMaterialList extends NWN implements API {
	
	public String parameter;//参数集合
	
	public String live_ids_1;//直播id

//	public String phone;//层级包id
	@Override
	public void initialize(HashMap<String, Object> data) {
		
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		live_ids_1 = MapUtil.getParameter_get(parameter, "live_ids").trim();
		
		// ArrayList< String> list = new ArrayList<>();
		// list.add("1");
		
		if ((!live_ids_1.equals("")) && live_ids_1.equals("code")) {
//			live_ids_1 = "["+ liveId +","+(Integer.parseInt(liveId)-1)+"]";
			live_ids_1 = "["+ liveId +"]";
			parameter = parameter.replace("live_ids=code", "live_ids="+ live_ids_1 );
		}
		
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Map<String,String> cookies=new HashMap<String,String>();
		cookies.put("admin_31_encode", admin_31_encode);
		cookies.put("PHPSESSID", PHPSESSID);
		cookies.put("admin_login_ssid", admin_login_ssid);
		
		MyRequest myRequest=new MyRequest();
		myRequest.setUrl(Url);
		myRequest.setCookies(cookies);
		myRequest.setRequest(Request);
		
		Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
	
		boolean result = true;
		String failReason = "";

		String json = re.asString();
//		System.out.println("response=========="+StringUtils.decodeUnicode(json));

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(getMsg(re));
			String code=getCode(re);
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("retcode") + ".";
			}

			/*System.out.println((data.get("msg") != null));
			System.out.println((msg != null));
			System.out.println(data.get("msg").toString().length());
			System.out.println(msg.length());
			*/
			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("0".equals(code)){
				//删除template_id表中的脚本生成的数据
				if (!isProduct && data.get("CleanDB").toString().contains("Y")) {
						try {
							deleteFromDB("iip.n_template", "id", template_id);
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
			}
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
