package com.offcn.api.nwn.service;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.io.UnsupportedEncodingException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.HttpRequest;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.api.nwn.md5.nwngetsign;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.system.MyRequest;
import com.offcn.TestUnti.ListUtil;

/**
 * 获取直播列表
 * 
 * @author liyy
 * 
 */
public class programLevel extends NWN implements API {

	public String parameter;// 参数集合
	public String t_id;//
	public String t_id_getdatabase;

	@Override
	public void initialize(HashMap<String, Object> data) {
		// try {
		// Thread.sleep(20000);
		// } catch (InterruptedException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
			Map<String,String> cookies=new HashMap<String,String>();
			cookies.put("PHPSESSID", PHPSESSID);
			cookies.put("admin_login_ssid", admin_login_ssid);		
			cookies.put("admin_31_encode", admin_31_encode);	
			MyRequest myRequest=new MyRequest();
			myRequest.setParameter(parameter);
			myRequest.setUrl(Url);
			myRequest.setRequest(Request);
			myRequest.setCookies(cookies);
			
			Response re = RequestDataUtils.RestAssuredApi(data, myRequest);
			return re;

	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = new JsonPath(re.asString());
		System.out.println("jp====" + jp);
		boolean result = true;
		String failReason = "";

		String json = re.asString();
		
		json = StringUtils.decodeUnicode(json);
		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {

			if (!json.contains(data.get("msg").toString())) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("message") + ".";
			}

			if (data.get("custom") != null && json != null) {
				// 如果自定义结果包含多个希望结果，也就是有逗号，那么就切割，包含比较。
				if (data.get("custom").toString().contains(",")) {
					String[] strCustomStrings = data.get("custom").toString()
							.split(",");
				//	System.out.println(strCustomStrings.length);
					for (int i = 0; i < strCustomStrings.length; i++) {
						if (!json.contains(strCustomStrings[i])) {
							result = result && false;
							failReason = failReason + "custom is expected "
									+ data.get("custom").toString()
									+ " but actually " + strCustomStrings[i]
									+ ".";
							break;
						}
					}
				} else {// 如果只有一个希望结果，就直接包含比较。
					if (!json.contains(data.get("custom").toString())) {
						result = result && false;
						failReason = failReason + "custom is expected "
								+ data.get("custom").toString()
								+ " but actually "
								+ data.get("custom").toString() + ".";
					}
				}
			}

			if("0".equals(jp.getString("retcode"))){
						
						//是否验证数据库
			}
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
